#!/bin/bash

# WatchData主目录ROOT
DDIR_ROOT=/opt/apps/com.wq.uosicbc
DDIR_FILES=$DDIR_ROOT/files
# 注册到firefox的P11模块名
P11_MODEL_NAME=watchdata
# PKCS11 so库名称
PKCS_LIB_NAME=libwdpkcs_icbc_51.so

who

function getUser {
    user=
    userPath=/run/systemd/users
    userFiles=`ls $userPath`
    for userFile in $userFiles
    do  
        if [ "${userFile}" -ge "500" ];then
            userState=`awk -F= '{ if($1=="STATE") print $2}' ${userPath}/${userFile}`
            if [ ${userState} == "active" ];then
                user=`awk -F= '{ if($1=="NAME") print $2}' ${userPath}/${userFile}`
                break
            fi  
        fi  
    done

    if [ "$user" == "" ];then
        user=root
    fi  
    echo $user
}

user=$(getUser)

if [ $user != root ];then
    home_path=/home/$user
else
    home_path=~
fi

profiledir=`cat $home_path/.mozilla/firefox/profiles.ini | sed -n -e 's/^.*Path=//p' | head -n 1`

if [ -e ${home_path}/.pki/nssdb ]; then
	echo "360 pki installed"
else
   mkdir ${home_path}/.pki
   sudo chown $user:$user ${home_path}/.pki
   mkdir ${home_path}/.pki/nssdb
   sudo chown $user:$user ${home_path}/.pki/nssdb
	if [ -f /usr/bin/modutil ]; then
		modutil -dbdir sql:${home_path}/.pki/nssdb -create -force
	else
		$DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.pki/nssdb -create -force
	fi
fi

if [ ! -e ${home_path}/.pki/nssdb/.config/qaxbrowser ]; then
    mkdir ${home_path}/.pki/nssdb/.config
    sudo chown $user:$user ${home_path}/.pki/nssdb/.config
    mkdir ${home_path}/.pki/nssdb/.config/qaxbrowser
    sudo chown $user:$user ${home_path}/.pki/nssdb/.config/qaxbrowser
    if [ -f /usr/bin/modutil ]; then
	modutil -dbdir sql:${home_path}/.pki/nssdb/.config/qaxbrowser -create -force
    else
	$DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.pki/nssdb/.config/qaxbrowser-create -force
    fi
fi

if [ ! -e ${home_path}/.config/qaxbrowser/.pki/nssdb ]; then
    mkdir ${home_path}/.config/qaxbrowser/.pki
    sudo chown $user:$user ${home_path}/.config/qaxbrowser/.pki
    mkdir ${home_path}/.config/qaxbrowser/.pki/nssdb
    sudo chown $user:$user ${home_path}/.config/qaxbrowser/.pki/nssdb

    if [ -f /usr/bin/modutil ]; then
        modutil -dbdir sql:${home_path}/.config/qaxbrowser/.pki/nssdb -create -force
    else
        $DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.config/qaxbrowser/.pki/nssdb -create -force
    fi
fi

if [ -f /usr/bin/modutil ]; then
   echo "modutil -dbdir ${home_path}/.mozilla/firefox/$profiledir -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   modutil -dbdir ${home_path}/.mozilla/firefox/$profiledir  -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
   echo "modutil -dbdir sql:${home_path}/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   modutil -dbdir sql:${home_path}/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
   echo "modutil -dbdir sql:${home_path}/.config/qaxbrowser/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   modutil -dbdir sql:${home_path}/.config/qaxbrowser/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
   echo "modutil -dbdir sql:${home_path}/.pki/nssdb/.config/qaxbrowser -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   modutil -dbdir sql:${home_path}/.pki/nssdb/.config/qaxbrowser -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
else
   echo "$DDIR_FILES/bin/modutil -dbdir ${home_path}/.mozilla/firefox/$profiledir -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   $DDIR_FILES/bin/modutil -dbdir ${home_path}/.mozilla/firefox/$profiledir  -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
   echo "$DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   $DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
   echo "$DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.pki/nssdb/.config/qaxbrowser -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   $DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.pki/nssdb/.config/qaxbrowser -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
   echo "$DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.config/qaxbrowser/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force"
   $DDIR_FILES/bin/modutil -dbdir sql:${home_path}/.config/qaxbrowser/.pki/nssdb -add "$P11_MODEL_NAME" -libfile "$DDIR_FILES/lib/$PKCS_LIB_NAME" -force
fi
echo "sudo chown $user:$user ${home_path}/.mozilla/firefox/$profiledir/ -R"
sudo chown $user:$user ${home_path}/.mozilla/firefox/$profiledir/ -R
sudo chmod 777 ${home_path}/.mozilla/firefox/$profiledir/ -R
echo "sudo chown $user:$user $home_path/.pki/nssdb/* -R"
sudo chown $user:$user $home_path/.pki/nssdb/* -R
sudo chmod 777 $home_path/.pki/nssdb/* -R
echo "sudo chown $user:$user $home_path/.pki/nssdb/.config/qaxbrowser/* -R"
sudo chown $user:$user $home_path/.pki/nssdb/.config/qaxbrowser/* -R
sudo chmod 777 $home_path/.pki/nssdb/.config/qaxbrowser/* -R
echo "sudo chown $user:$user $home_path/.config/qaxbrowser/.pki/nssdb/* -R"
sudo chown $user:$user $home_path/.config/qaxbrowser/.pki/nssdb/* -R
sudo chmod 777 $home_path/.config/qaxbrowser/.pki/nssdb/* -R
