#! /bin/bash
prog="WDUIServer_icbc"
BIN_PATH=/opt/apps/com.wq.uosicbc/files/tools
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$BIN_PATH
RUNJAR=`ps -ef | grep ${prog} | grep -v grep | awk '{print $2}'`
if [ "x${RUNJAR}" != "x" ]; then
    echo "Program is already running." >> /tmp/uilog.txt
    exit 0
fi

runUser=`whoami`
echo "runUser=$runUser" >> /tmp/uilog.txt

function getUser {
    user=
    userPath=/run/systemd/users
    userFiles=`ls $userPath`
    for userFile in $userFiles
    do  
        if [ "${userFile}" -ge "500" ];then
            userState=`awk -F= '{ if($1=="STATE") print $2}' ${userPath}/${userFile}`
            if [ ${userState} == "active" ];then
                user=`awk -F= '{ if($1=="NAME") print $2}' ${userPath}/${userFile}`
                break
            fi  
        fi  
    done

    if [ "$user" == "" ];then
        user=root
    fi  
    echo $user
}

showUser=$(getUser)

if [ ! $DISPLAY ]; then
    export DISPLAY=:0
    export LANG=zh_CN.UTF-8
    export XAUTHORITY=/home/$showUser/.Xauthority
fi

cd "${BIN_PATH}"
if [ "$runUser" != "$showUser" ]; then
    ../bin/openxhost.sh >> /tmp/uilog.txt
    env >> /tmp/uilog.txt
    xhost >> /tmp/uilog.txt
fi

./${prog} >>/tmp/uilog.txt 2>&1 &
